%{
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "page.h"

extern FILE *yyin;
extern int line;
page pres,   curpage;
frame       curframe;
int pageno = 0;

void addframe(int type );


void addword( char* s )
{ frame l;
  words q, w;
  l = curframe;
  w = calloc( 1 , sizeof(enrword) );
  w->next = NULL;
  w->str  = s;
  if ( ! l->file ){
     l->file  = w;
     return;
  }
  q = l->file;
  while ( q->next )
     q = q->next;
  q->next = w;
}

void addpunct( int s  )
{ frame l;
  words q, w;
  l = curframe;
  w = calloc( 1 , sizeof(enrword) );
  w->next = NULL;
  w->car  = s;
  if ( ! l->file ){
     l->file  = w;
     return;
  }
  q = l->file;
  while ( q->next )
     q = q->next;
  q->next = w;
}



extern int yylex( void );
int yyerror( char *msg );

%}
%union{
  char *str;
  int  val;
}

%token ITEM   PG PD SLIDE ZONE STR NL NB BY WORD SEP HIDDEN PLAN ALARM HEIGHT PLAY PROG TITLE ASCII SRC PROMPT TERM COLOR FLAG THIS PUNCT AT
%type  <str>  PLAN STR WORD TITLE SRC PROMPT
%type  <val>  NB HEIGHT PROG COLOR FLAG PUNCT

%%

PRES   : PAGES
PAGES  : PAGE  { 
           curpage->num = ++pageno;
           inspage(curpage, pres); 
           curpage = initpage(); 
       } PAGES
       | /*empty*/
       ;
PAGE  : SLIDE PG ATTRS  PD FRAMES 
       ;

ATTRS : ATTR SEP ATTRS
      | ATTR
      ;

ATTR  : STR   {curpage->title = $1;} ;
      | PLAN  {curpage->plan  = $1;} ;
      | NL    {curpage->bound  = 0;} ;
      ;    
FRAMES  : FRAME  ACTION   WORDS PROMPTS FRAMES
      | /* empty 	*/
      ;
        ;
ACTION  : PLAY PG PARMS  PD { curframe->boxattr = COLOR_PAIR( BLUE_PAIR); }
        | /* empty */
        ;
PARMS   : PARM SEP PARMS
        | PARM
        ;

PARM    : STR  { curframe->arg  = $1; }
        | PROG { curframe->prog = $1; } 
        ;

WORDS : WORD  { addword( $1 ) } WORDS 
      | PUNCT { addpunct( $1 ) } WORDS
      | /* empty */
      ;
FRAME   :  ZONE   { addframe( ZONE  ) ;} PG ATTRIBS PD  
        |  ALARM  { addframe( ALARM ) ;} PG ATTRIBS PD 
        |  ASCII  { addframe( ASCII ) ;} PG ATTRIBS PD
        |  TERM   { addframe( TERM  ) ;} PG ATTRIBS PD  
        |  THIS   { addframe( THIS  ) ;} PG ATTRIBS PD  
        ;
PROMPTS : PROMPT { addword( $1 ) }  PROMPTS
        | /* empty */
        ;
      
ATTRIBS : ATTRIB  SEP ATTRIBS
        | ATTRIB
        | /* empty */
        ;
ATTRIB  : STR { curframe->label = $1;}
        | NB BY NB { curframe->width = $3; 
                     curframe->height= $1;
                   }
        | AT NB BY NB { curframe->x = $2; 
                        curframe->y = $4;
                   }
        | PLAN        { curframe->plan   = $1;} 
        | NL          { curframe->bound  = 0;} 
        | HEIGHT      { curframe->height = $1;} 
        | FLAG        { curframe->flag   = $1;} 
        | HIDDEN      { curframe->hidden = 1;}
        | SRC  STR    { curframe->src = $2;  }
        | COLOR       { curframe->txtattr = COLOR_PAIR($1) ;}
        ;

%%

page loadpage( char *fn )
{
yyin  = fopen( fn, "r" );
pres  = initpage( ); 
pres->prev = pres;
pres->next = pres;
curpage    =  pres;
yyparse();
fclose(yyin);
return pres;
}

int yyerror( char *msg ) { 
fprintf(stderr, "%3d : %s", line, msg);
exit(1);
return 0; 
}

void addframe( int type )
{ frame aux, l;
  aux = calloc( 1, sizeof(enrframe) );
  aux->type   =  type;
  aux->width  =  0;
  aux->height =  0;
  aux->bound  =  1;
  aux->label  =  NULL;
  aux->x = startx;
  aux->y = starty;
  switch ( type ) {
      case ALARM : aux->hidden =  1; 
                   aux->labattr = COLOR_PAIR( RED_PAIR );
                   aux->txtattr = COLOR_PAIR( RED_PAIR ) ;
                   aux->boxattr = COLOR_PAIR( RED_PAIR ) ;
                   break;
      case ZONE : case ASCII  : case THIS : aux->hidden =  0;
                   aux->labattr = COLOR_PAIR( WHITE_PAIR );
  		   aux->txtattr = COLOR_PAIR( WHITE_PAIR ) ;
                   aux->boxattr = COLOR_PAIR( YELLOW_PAIR ) ;
                   break;
      case TERM  : aux->hidden =  0;
                   aux->labattr = COLOR_PAIR( GREEN_PAIR );
  		   aux->txtattr = COLOR_PAIR( GREEN_PAIR ) ;
                   aux->boxattr = COLOR_PAIR( GREEN_PAIR ) ;
                   break;
  }
  aux->next   =  NULL;
  curframe = aux;
  if ( ! curpage->fil ) {
	 curpage->fil = aux;
	return;
  }
  l = curpage->fil;
  while ( l -> next ) l = l -> next;
  l -> next = aux;
}




