%{
 #include <ctype.h>
#include "frame.h"
#include "parse.tab.h"
int line  = 1;
int value = 0;

char buffer[1024];
char *ptr, *src;

typedef struct _symb_ {
  char* key;
  struct _symb_ * next;
} enrs, *symb;
symb ts   = NULL;

int iskw( char * k )
  { char p[64];
    int i = 0;     
    if ( ! k ) return 0;
    symb x = ts;
    while ( *k ) 
      p[i++] = toupper( *k++ );
    p[i] = 0;
    while ( x ) {
     if ( strcmp( x->key, p ) == 0 )
        return 1;
     x = x -> next;
    }
    
    return 0;
  } 

symb addkw( char * k )
  { char *p;
    symb x;
    x = ts;
    p = k;
    while ( *p ) {
	*p=toupper( *p );
	p++;
    }
    while ( x ) {
     if ( strcmp( x->key, k ) == 0 )
     return x;
     x = x -> next;
    }
    x = malloc( sizeof( enrs) );
    fprintf( stderr, "\nkw=%s", k );
    x->key = strdup( k );
    x->next = ts;   
    ts = x;
    return x;
  } 

void inskws( char * s )
{  char buf[64], *p, *t;
  
   while ( ! isspace(*s) ) s++;
   while ( *s ) {
      while ( *s && isspace(*s ) ) s++;
      if ( *s ) {
       
          p = (char*) & buf[0] ;
          t = p;
          while ( *s && ! isspace( *s) ) 
            *p++ = *s++;
          *p=0;
           addkw( t  );
      }
   }
}
%}

%s string attrib prompt text
%%

^"#".*       ;
<attrib>\"      ptr=(char*)&buffer; BEGIN(string);
<string>[^"]    *ptr++=*yytext;
<string>\"      *ptr=0;yylval.str=strdup( buffer ); BEGIN(attrib);return STR;
 
<attrib>[0-9]+  yylval.val = atoi( yytext ); return NB;
<attrib>"shell"   yylval.val = SHELL; return PROG;
<attrib>"vim"   yylval.val = VIM; return PROG;
<attrib>"lynx"  yylval.val = LYNX;return PROG;
<attrib>"noline"    return NL;
<attrib>"bottom" yylval.val = 2;    return FLAG;
<attrib>"by"    return BY;
<attrib>"at"    return AT;
<attrib>"red"     yylval.val = RED_PAIR; return COLOR;
<attrib>"green"   yylval.val = GREEN_PAIR; return COLOR;
<attrib>"white"   yylval.val = WHITE_PAIR; return COLOR;
<attrib>"blue"    yylval.val = BLUE_PAIR; return COLOR;
<attrib>"yellow"   yylval.val = YELLOW_PAIR; return COLOR;
<attrib>"cyan"   yylval.val = CYAN_PAIR; return COLOR;
<attrib>"magenta"   yylval.val = MAGENTA_PAIR; return COLOR;
<attrib>"src"   return SRC;
<attrib>"hidden"  return HIDDEN;
<attrib>"height="[0-9]+   sscanf(yytext,"height=%d", &yylval.val);return HEIGHT;
<attrib>[A-Z!]+   yylval.str=strdup(yytext);return PLAN;
<attrib>","     return SEP;
<attrib>"["     return PG;
<attrib>"]"     BEGIN(INITIAL);return PD; 
"\\slide"       BEGIN(attrib); return SLIDE; 
"\\exit"        return 0;
"\\zone"        BEGIN(attrib); return ZONE;
"\\term"        BEGIN(attrib); return TERM;
"\\this"        BEGIN(attrib); return THIS;
"\\alarm"       BEGIN(attrib); return ALARM;
"\\ascii"       BEGIN(attrib); return ASCII;
"\\play"        BEGIN(attrib); return PLAY;
"\\title".*     yylval.str = strdup( (char*) &yytext[6] ); return TITLE;
"\\keyword".*   inskws( yytext );
"\\prompt"      BEGIN(prompt);
"\\text"        BEGIN(text);
<prompt>^"$".*  yylval.str = strdup( yytext );     return PROMPT;
<prompt>^".".*  yylval.str = strdup( yytext );     return PROMPT;
<prompt>^"-".*  yylval.str = strdup( yytext );     return PROMPT;
<text>[a-zA-Z0-9àéêèùôûîïçâ]+  yylval.str=strdup( yytext ); return WORD;
<text>[[:punct:]]  yylval.val=yytext[0];        return PUNCT;
<text>[[:space:]]+     yylval.val=' ';          return PUNCT;
.            ;
\n           line++;
%%
